/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2009-2024                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2016                                                **
**  TU Dresden, Zentrum fuer Informationsdienste und Hochleistungsrechnen  **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


/**
 * @file
 *
 * Implements the representation and analysis of library dependencies
 */

#include <config.h>

#include <iostream>
#include <stdlib.h>
#include <cstring>

#include <cubew_config.hpp>

#include <cubew_config_data.hpp>

#include <config-external-libs-backend.hpp>

using namespace std;

cubew_config_data*
cubew_config_get_backend_data()
{
    static cubew_config_data data;

    data.m_cc             = "gcc -std=gnu99";
    data.m_cppflags       = "-I/usr/include/cubew";
    data.m_incldir        = "/usr/include/cubew";
    data.m_use_rpath_flag = ( 0 != 0 );
    data.m_rpath_flag_cc  = "$wl-rpath $wl$libdir";
    data.m_wl_flag        = "-Wl,";
    data.m_aix_libpath    = "";
    // No linker/loader search path filtering for now, see scorep#415
    data.m_sys_lib_search_path   = ""; // "/usr/lib/gcc/s390x-redhat-linux/15 /usr/lib64 /lib64 /usr/lib /lib ";
    data.m_sys_lib_dlsearch_path = ""; // "/usr/lib64 /lib /usr/lib ";

    add_library_dependencies_backend( &data.m_library_objects );

    data.prepare_rpath_flags();

    return &data;
}
